package com.fs.starfarer.api.impl.campaign.econ.impl;

import java.util.HashMap;
import java.util.Map;

import com.fs.starfarer.api.campaign.SpecialItemData;
import com.fs.starfarer.api.campaign.econ.Industry;
import com.fs.starfarer.api.campaign.econ.InstallableIndustryItemPlugin.InstallableItemDescriptionMode;
import com.fs.starfarer.api.ui.TooltipMakerAPI;
import com.fs.starfarer.api.util.Misc;

import static com.fs.starfarer.api.impl.campaign.econ.impl.ItemEffectsRepo.NO_TRANSPLUTONIC_ORE_DEPOSITS;
import static com.fs.starfarer.api.impl.campaign.econ.impl.ItemEffectsRepo.NO_VOLATILES_DEPOSITS;

@SuppressWarnings("serial")
public class sfc_specialItemsEffectRepo {

    public static int AQUATIC_STIMULATOR_BONUS = 1;
    public static Map<String, InstallableItemEffect> ITEM_EFFECTS = new HashMap<String, InstallableItemEffect>() {
        {
            put("sfc_aquaticstimulator", new BoostIndustryInstallableItemEffect(
                    "sfc_aquaticstimulator", AQUATIC_STIMULATOR_BONUS, 0) {
                protected void addItemDescriptionImpl(Industry industry, TooltipMakerAPI text, SpecialItemData data,
                                                      InstallableItemDescriptionMode mode, String pre, float pad) {
                    text.addPara(pre + "Increases aquaculture production by %s unit.",
                            pad, Misc.getHighlightColor(),
                            "" + (int) AQUATIC_STIMULATOR_BONUS);
                }
                @Override
                public String[] getSimpleReqs(Industry industry) {
                    return new String[]{NO_TRANSPLUTONIC_ORE_DEPOSITS, NO_VOLATILES_DEPOSITS};
                }
            });
        }
    };
}