package data.scripts;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.*;
import com.fs.starfarer.api.campaign.econ.Industry;
import com.fs.starfarer.api.characters.FullName;
import com.fs.starfarer.api.characters.FullName.Gender;
import com.fs.starfarer.api.characters.ImportantPeopleAPI;
import com.fs.starfarer.api.characters.PersonAPI;
import com.fs.starfarer.api.BaseModPlugin;
import com.fs.starfarer.api.impl.campaign.econ.impl.BaseIndustry;
import com.fs.starfarer.api.impl.campaign.fleets.FleetFactoryV3;
import com.fs.starfarer.api.impl.campaign.fleets.FleetParamsV3;
import com.fs.starfarer.api.impl.campaign.ids.*;
import com.fs.starfarer.api.campaign.econ.MarketAPI;
import com.fs.starfarer.api.impl.campaign.events.OfficerManagerEvent;

import com.fs.starfarer.api.impl.campaign.skills.OfficerTraining;
public class sfc_ModPlugin extends BaseModPlugin {

    public static boolean isDE = Global.getSettings().getModManager().isModEnabled("Diktat Enhancement");
    public static boolean isCSP = Global.getSettings().getModManager().isModEnabled("Csp");

    public static String sfckween = "sfckween"; //glorious science
    public static String sfcruni = "sfcruni"; //looks familiar
    public static String sfcruni2 = "sfcruni2"; //you have met a terrible fate haven't you
    public static String sfcyenni = "sfcyenni"; //also looks familiar
    public static String sfcmann = "sfcmann"; //2nd coolest old guy in the Sindrian Fuel Company
    public static String sfcruy = "sfcruy"; //envious of the lion's guard
    public static String sfcdunn = "sfcdunn"; //loves "surprise internship" camps
    public static String sfcfleures = "sfcfleures"; //brightest flower
    public static String sfcjenkins = "sfcjenkins"; //valmarie's sass
    public static String sfcfakeandrada = "sfcfakeandrada"; //the phillip andrada experience
    public static String dejalecto = "dejalecto"; //preacher for the Lion and DE integration
    public static String cspmongaera = "cspmongaera"; //deathless
    public static String nftpononzi = "nftpononzi"; //does he have an ape?
    public static String nftgimlet = "nftgimlet"; //ol' gimlet eye

    private static void addGrandFuelFleet() {
        SectorAPI sector = Global.getSector();
        StarSystemAPI system = sector.getStarSystem("Askonia");
        SectorEntityToken sfcvol = system.getEntityById("volturn");
        
        ImportantPeopleAPI ip = Global.getSector().getImportantPeople();

        PersonAPI sfcyenniPerson = Global.getFactory().createPerson();
        sfcyenniPerson.setId(sfcyenni);
        sfcyenniPerson.setFaction(Factions.DIKTAT);
        sfcyenniPerson.setGender(Gender.FEMALE);
        sfcyenniPerson.setPostId("sfcfleetadmiral");
        sfcyenniPerson.setRankId(Ranks.SPACE_ADMIRAL);
        sfcyenniPerson.setPersonality(Personalities.AGGRESSIVE);
        sfcyenniPerson.setImportance(PersonImportance.HIGH);
        sfcyenniPerson.setVoice(Voices.SOLDIER);
        sfcyenniPerson.getName().setFirst("Ruka");
        sfcyenniPerson.getName().setLast("Yenni");
        sfcyenniPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcyenni"));
        sfcyenniPerson.getStats().setLevel(15);
        sfcyenniPerson.getStats().setSkillLevel("sfc_titan", 3);
        sfcyenniPerson.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 3);
        sfcyenniPerson.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 3);
        sfcyenniPerson.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 3);
        sfcyenniPerson.getStats().setSkillLevel(Skills.FIELD_MODULATION, 3);
        sfcyenniPerson.getStats().setSkillLevel(Skills.IMPACT_MITIGATION, 3);
        sfcyenniPerson.getStats().setSkillLevel(Skills.HELMSMANSHIP, 3);
        sfcyenniPerson.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 3);
        sfcyenniPerson.getStats().setSkillLevel(Skills.ENERGY_WEAPON_MASTERY, 3);
        sfcyenniPerson.getStats().setSkillLevel(Skills.POLARIZED_ARMOR, 3);
        sfcyenniPerson.getStats().setSkillLevel(Skills.COORDINATED_MANEUVERS, 1);
        sfcyenniPerson.getStats().setSkillLevel(Skills.CREW_TRAINING, 1);
        sfcyenniPerson.getStats().setSkillLevel(Skills.OFFICER_TRAINING, 1);
        sfcyenniPerson.getStats().setSkillLevel(Skills.SUPPORT_DOCTRINE, 1);
        sfcyenniPerson.getStats().setSkillLevel(Skills.TACTICAL_DRILLS, 1);
        sfcyenniPerson.getStats().setSkillLevel(Skills.OFFICER_MANAGEMENT, 1);
        sfcyenniPerson.addTag("coff_forcecapture");
        sfcyenniPerson.addTag("coff_prisonerdialog");
        sfcyenniPerson.getMemoryWithoutUpdate().set("$coff_allowedactions", "talk");
        sfcyenniPerson.getMemoryWithoutUpdate().set("$coff_dialogtrigger", "sfcyenni");
        sfcyenniPerson.getMemoryWithoutUpdate().set("$nex_noOfficerDeath", true);
        sfcyenniPerson.getMemoryWithoutUpdate().set("$chatterChar", "sfcyenni");
        ip.addPerson(sfcyenniPerson);

        PersonAPI person1 = Global.getSector().getFaction("sindrian_diktat").createRandomPerson(FullName.Gender.ANY);
        person1.setId("sfc_generic_officer1");
        person1.setPostId(Ranks.POST_OFFICER);
        person1.setRankId(Ranks.POST_OFFICER);
        person1.setPersonality(Personalities.AGGRESSIVE);
        person1.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 2);
        person1.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 3);
        person1.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 3);
        person1.getStats().setSkillLevel(Skills.FIELD_MODULATION, 3);
        person1.getStats().setSkillLevel(Skills.IMPACT_MITIGATION, 3);
        person1.getStats().setSkillLevel(Skills.HELMSMANSHIP, 2);
        person1.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 2);
        person1.addTag("coff_nocapture");
        person1.getStats().setLevel(7);

        PersonAPI person2 = Global.getSector().getFaction("sindrian_diktat").createRandomPerson(FullName.Gender.ANY);
        person2.setId("sfc_generic_officer2");
        person2.setPostId(Ranks.POST_OFFICER);
        person2.setRankId(Ranks.POST_OFFICER);
        person2.setPersonality(Personalities.AGGRESSIVE);
        person2.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 2);
        person2.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 3);
        person2.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 3);
        person2.getStats().setSkillLevel(Skills.FIELD_MODULATION, 3);
        person2.getStats().setSkillLevel(Skills.IMPACT_MITIGATION, 3);
        person2.getStats().setSkillLevel(Skills.HELMSMANSHIP, 2);
        person2.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 2);
        person2.addTag("coff_nocapture");
        person2.getStats().setLevel(7);

        PersonAPI person3 = Global.getSector().getFaction("sindrian_diktat").createRandomPerson(FullName.Gender.ANY);
        person3.setId("sfc_generic_officer3");
        person3.setPostId(Ranks.POST_OFFICER);
        person3.setRankId(Ranks.POST_OFFICER);
        person3.setPersonality(Personalities.AGGRESSIVE);
        person3.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 2);
        person3.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 3);
        person3.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 3);
        person3.getStats().setSkillLevel(Skills.FIELD_MODULATION, 3);
        person3.getStats().setSkillLevel(Skills.IMPACT_MITIGATION, 3);
        person3.getStats().setSkillLevel(Skills.HELMSMANSHIP, 2);
        person3.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 2);
        person3.addTag("coff_nocapture");
        person3.getStats().setLevel(7);

        PersonAPI person4 = Global.getSector().getFaction("sindrian_diktat").createRandomPerson(FullName.Gender.ANY);
        person4.setId("sfc_generic_officer4");
        person4.setPostId(Ranks.POST_OFFICER);
        person4.setRankId(Ranks.POST_OFFICER);
        person4.setPersonality(Personalities.AGGRESSIVE);
        person4.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 2);
        person4.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 3);
        person4.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 3);
        person4.getStats().setSkillLevel(Skills.FIELD_MODULATION, 3);
        person4.getStats().setSkillLevel(Skills.IMPACT_MITIGATION, 3);
        person4.getStats().setSkillLevel(Skills.HELMSMANSHIP, 2);
        person4.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 2);
        person4.addTag("coff_nocapture");
        person4.getStats().setLevel(7);

        PersonAPI person5 = Global.getSector().getFaction("sindrian_diktat").createRandomPerson(FullName.Gender.ANY);
        person5.setId("sfc_generic_officer5");
        person5.setPostId(Ranks.POST_OFFICER);
        person5.setRankId(Ranks.POST_OFFICER);
        person5.setPersonality(Personalities.AGGRESSIVE);
        person5.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 2);
        person5.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 3);
        person5.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 3);
        person5.getStats().setSkillLevel(Skills.FIELD_MODULATION, 3);
        person5.getStats().setSkillLevel(Skills.IMPACT_MITIGATION, 3);
        person5.getStats().setSkillLevel(Skills.HELMSMANSHIP, 2);
        person5.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 2);
        person5.addTag("coff_nocapture");
        person5.getStats().setLevel(7);

        PersonAPI person6 = Global.getSector().getFaction("sindrian_diktat").createRandomPerson(FullName.Gender.ANY);
        person6.setId("sfc_generic_officer6");
        person6.setPostId(Ranks.POST_OFFICER);
        person6.setRankId(Ranks.POST_OFFICER);
        person6.setPersonality(Personalities.AGGRESSIVE);
        person6.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 2);
        person6.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 3);
        person6.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 3);
        person6.getStats().setSkillLevel(Skills.FIELD_MODULATION, 3);
        person6.getStats().setSkillLevel(Skills.IMPACT_MITIGATION, 3);
        person6.getStats().setSkillLevel(Skills.HELMSMANSHIP, 2);
        person6.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 2);
        person6.addTag("coff_nocapture");
        person6.getStats().setLevel(7);

        PersonAPI reckless1 = Global.getSector().getFaction("sindrian_diktat").createRandomPerson(FullName.Gender.ANY);
        reckless1.setId("sfc_reckless1");
        reckless1.setPostId(Ranks.POST_OFFICER);
        reckless1.setRankId(Ranks.POST_OFFICER);
        reckless1.setPersonality(Personalities.RECKLESS);
        reckless1.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 3);
        reckless1.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 3);
        reckless1.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 3);
        reckless1.getStats().setSkillLevel(Skills.FIELD_MODULATION, 3);
        reckless1.getStats().setSkillLevel(Skills.IMPACT_MITIGATION, 2);
        reckless1.getStats().setSkillLevel(Skills.HELMSMANSHIP, 2);
        reckless1.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 2);
        reckless1.addTag("coff_nocapture");
        reckless1.getStats().setLevel(7);

        PersonAPI reckless2 = Global.getSector().getFaction("sindrian_diktat").createRandomPerson(FullName.Gender.ANY);
        reckless2.setId("sfc_reckless2");
        reckless2.setPostId(Ranks.POST_OFFICER);
        reckless2.setRankId(Ranks.POST_OFFICER);
        reckless2.setPersonality(Personalities.RECKLESS);
        reckless2.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 3);
        reckless2.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 3);
        reckless2.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 3);
        reckless2.getStats().setSkillLevel(Skills.FIELD_MODULATION, 3);
        reckless2.getStats().setSkillLevel(Skills.IMPACT_MITIGATION, 2);
        reckless2.getStats().setSkillLevel(Skills.HELMSMANSHIP, 2);
        reckless2.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 2);
        reckless2.addTag("coff_nocapture");
        reckless2.getStats().setLevel(7);

        PersonAPI reckless3 = Global.getSector().getFaction("sindrian_diktat").createRandomPerson(FullName.Gender.ANY);
        reckless3.setId("sfc_reckless3");
        reckless3.setPostId(Ranks.POST_OFFICER);
        reckless3.setRankId(Ranks.POST_OFFICER);
        reckless3.setPersonality(Personalities.RECKLESS);
        reckless3.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 3);
        reckless3.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 3);
        reckless3.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 3);
        reckless3.getStats().setSkillLevel(Skills.FIELD_MODULATION, 3);
        reckless3.getStats().setSkillLevel(Skills.IMPACT_MITIGATION, 2);
        reckless3.getStats().setSkillLevel(Skills.HELMSMANSHIP, 2);
        reckless3.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 2);
        reckless3.addTag("coff_nocapture");
        reckless3.getStats().setLevel(7);


            FleetParamsV3 params = new FleetParamsV3(
                    sfcvol.getMarket(), // add a source(has to be from a MarketAPI)
                    null, // loc in hyper; don't need if have market
                    "sindrian_diktat",
                    2f, // quality override route.getQualityOverride()
                    FleetTypes.PATROL_LARGE,
                    1f, // combatPts(minimal so special ships can be added)(1000f otherwise)
                    0f, // freighterPts
                    0f, // tankerPts
                    0f, // transportPts
                    0f, // linerPts
                    0f, // utilityPts
                    0f// qualityMod
            );
            params.officerNumberMult = 2f;
            params.officerLevelBonus = 4;
            params.officerNumberBonus = 4;
            params.officerLevelLimit = 10; // Global.getSettings().getInt("officerMaxLevel") + (int) OfficerTraining.MAX_LEVEL_BONUS;
            params.modeOverride = FactionAPI.ShipPickMode.PRIORITY_THEN_ALL;
            params.averageSMods = 1;
            params.commander = Global.getSector().getImportantPeople().getPerson(sfcyenni);
            params.flagshipVariantId = "sfciapetus_Mixed";
            CampaignFleetAPI fleet = FleetFactoryV3.createFleet(params);
            if (fleet == null || fleet.isEmpty()) return;
            fleet.setFaction("sindrian_diktat", true);
            fleet.getFlagship().setShipName("SFS Fuel Eternal");
            fleet.getFlagship().setId("sfciapetus_Mixed");
            fleet.getFleetData().addFleetMember("sfcskyrend_Barrage").setCaptain(person1);
            fleet.getFleetData().addFleetMember("sfcskyrend_Beamer");
            fleet.getFleetData().addFleetMember("sfcprometheus_vanguard").setCaptain(person2);
            fleet.getFleetData().addFleetMember("sfcprometheus_barrage");
            fleet.getFleetData().addFleetMember("sfcmenoetius_Defense");
            fleet.getFleetData().addFleetMember("sfcepimetheus_Experimental").setCaptain(person3);
            fleet.getFleetData().addFleetMember("sfccrius_Blaster").setCaptain(person4);
            fleet.getFleetData().addFleetMember("sfccrius_Blaster");
            fleet.getFleetData().addFleetMember("sfccrius_Pressure");
            fleet.getFleetData().addFleetMember("sfccrius_Pressure");
            fleet.getFleetData().addFleetMember("sfcphaeton_bombard").setCaptain(person5);
            fleet.getFleetData().addFleetMember("sfcphaeton_bombard");
            fleet.getFleetData().addFleetMember("sfcphaeton_ballistics").setCaptain(person6);
            fleet.getFleetData().addFleetMember("sfcphaeton_ballistics");
            fleet.getFleetData().addFleetMember("sfcarke_Supporter");
            fleet.getFleetData().addFleetMember("sfcarke_Supporter");
            fleet.getFleetData().addFleetMember("sfcarke_Suppression");
            fleet.getFleetData().addFleetMember("sfcarke_Suppression");
            fleet.getFleetData().addFleetMember("sfcclepsydra_Standard");
            fleet.getFleetData().addFleetMember("sfcclepsydra_Standard");
            fleet.getFleetData().addFleetMember("sfcdram_assault");
            fleet.getFleetData().addFleetMember("sfcdram_missile");
            fleet.getFleetData().addFleetMember("sfclelantus_Barrage");
            fleet.getFleetData().addFleetMember("sfclelantus_Vanguard");
            fleet.getFleetData().addFleetMember("sfctahlanbento_Pulser");
            fleet.getFleetData().addFleetMember("sfcbia_Hunter");
            fleet.getFleetData().addFleetMember("sfcbia_Hunter");
            fleet.getFleetData().addFleetMember("sfctalaria_Beamer").setCaptain(reckless1);
            fleet.getFleetData().addFleetMember("sfctalaria_Strike").setCaptain(reckless2);
            fleet.getFleetData().addFleetMember("sfctalaria_Overdriven").setCaptain(reckless3);
            fleet.getFleetData().addFleetMember("sfcslent_Offense");
            fleet.getFleetData().addFleetMember("sfcslent_Offense");
            fleet.getFleetData().addFleetMember("sfcslent_Offense");
            fleet.getFleetData().addFleetMember("sfcslent_Offense");
            fleet.getFleetData().addFleetMember("sfcslent_Offense");
            fleet.getFleetData().addFleetMember("sfcpolus_Torpedo");
            fleet.getFleetData().addFleetMember("sfcpolus_Torpedo");
            fleet.getFleetData().addFleetMember("sfcpolus_Torpedo");
            fleet.getFleetData().addFleetMember("sfccoeus_Patrol");
            fleet.getFleetData().addFleetMember("sfccoeus_Patrol");
            fleet.setNoFactionInName(true);
            fleet.setName("The Grand Fuel Fleet");
            sfcvol.getContainingLocation().addEntity(fleet);
            fleet.setAI(Global.getFactory().createFleetAI(fleet));
            //fleet.setMarket(sfcvol.getMarket());
            fleet.setLocation(sfcvol.getLocation().x, sfcvol.getLocation().y);
            fleet.setFacing((float) Math.random() * 360f);
            fleet.getAI().addAssignment(FleetAssignment.DEFEND_LOCATION, sfcvol, (float) Math.random() * 90000f, null);
            fleet.getMemoryWithoutUpdate().set("$chatter_introSplash_name", fleet.getCommander().getNameString());
        }

    private void addNFTMerchantMilitia() {
        SectorAPI sector = Global.getSector();
        StarSystemAPI system = sector.getStarSystem("Naraka");
        SectorEntityToken nachiketa = system.getEntityById("nachiketa");
        FleetParamsV3 params = new FleetParamsV3(
                nachiketa.getMarket(), // add a source(has to be from a MarketAPI)
                null, // loc in hyper; don't need if have market
                "hegemony",
                1f, // quality override route.getQualityOverride()
                FleetTypes.TASK_FORCE,
                50f, // combatPts(minimal so special ships can be added)
                0f, // freighterPts
                0f, // tankerPts
                0f, // transportPts
                0f, // linerPts
                0f, // utilityPts
                0f// qualityMod
        );
        params.officerNumberMult = 1f;
        params.officerLevelBonus = 3;
        params.officerNumberBonus = 3;
        params.officerLevelLimit = Global.getSettings().getInt("officerMaxLevel") + (int) OfficerTraining.MAX_LEVEL_BONUS;
        params.modeOverride = FactionAPI.ShipPickMode.ALL;
        params.averageSMods = 1;
        params.flagshipVariantId = "eagle_xiv_Elite";
        CampaignFleetAPI fleet = FleetFactoryV3.createFleet(params);
        if (fleet == null || fleet.isEmpty()) return;
        fleet.setFaction("hegemony", true);
        fleet.getFlagship().setShipName("NMS Pyramid");
        fleet.getFlagship().setId("eagle_xiv_Elite");
        fleet.getFleetData().addFleetMember("condor_Support");
        fleet.getFleetData().addFleetMember("condor_Support");
        fleet.getFleetData().addFleetMember("hammerhead_Support");
        fleet.getFleetData().addFleetMember("hammerhead_Support");
        fleet.getFleetData().addFleetMember("hammerhead_Support");
        fleet.getFleetData().addFleetMember("enforcer_Balanced");
        fleet.getFleetData().addFleetMember("enforcer_Balanced");
        fleet.getFleetData().addFleetMember("enforcer_Balanced");
        fleet.getFleetData().addFleetMember("manticore_Support");
        fleet.getFleetData().addFleetMember("manticore_Support");
        fleet.getFleetData().addFleetMember("manticore_Support");
        fleet.getFleetData().addFleetMember("mule_Standard");
        fleet.getFleetData().addFleetMember("mule_Standard");
        fleet.getFleetData().addFleetMember("mule_Standard");
        fleet.getFleetData().addFleetMember("mule_Standard");
        fleet.getFleetData().addFleetMember("kite_hegemony_Interceptor");
        fleet.getFleetData().addFleetMember("kite_hegemony_Interceptor");
        fleet.getFleetData().addFleetMember("kite_hegemony_Interceptor");
        fleet.getFleetData().addFleetMember("kite_Support");
        fleet.getFleetData().addFleetMember("kite_Support");
        fleet.getFleetData().addFleetMember("kite_Support");
        fleet.setNoFactionInName(true);
        fleet.setName("NFT, Inc. Merchant Militia");
        nachiketa.getContainingLocation().addEntity(fleet);
        fleet.setAI(Global.getFactory().createFleetAI(fleet));
        fleet.setLocation(nachiketa.getLocation().x, nachiketa.getLocation().y);
        fleet.setFacing((float) Math.random() * 360f);
        fleet.getAI().addAssignment(FleetAssignment.DEFEND_LOCATION, nachiketa, (float) Math.random() * 90000f, null);
    }

    @Override
    public void onApplicationLoad(){
        Global.getSettings().getSkillSpec(Skills.ORDNANCE_EXPERTISE).setDescription("There's more to antimatter fuel than simply just fueling starships. Why, with just a bit of ingenuity, you'll find there's plenty of things which can benefit from a bit of antimatter reactions.");
        Global.getSettings().getSkillSpec(Skills.ORDNANCE_EXPERTISE).setAuthor("Chapter 15 of The Sindrian Fuel Company: From Dreams to Reality");
        Global.getSettings().getIndustrySpec("lionsguard").setDesc("Headquarters of the elite paramilitary branch of the Sindrian Fuel Company, under the direct control of Supreme Overlord Executive Gas Station Manager Phillip Andrada. The Lion's Guard consists of the most devoted employees, who receive top quality training and equipment to protect Sindrian Fuel assets and ensure the continued competitiveness of Sindrian Antimatter Fuel throughout the sector. Many question why a company like Sindrian Fuel would require such a heavily armed paramilitary unit when most duties are handled by regular security forces, but these questions usually are silenced by reminders of how dangerous the Persean Sector is and a note that the Lion's Guard is solely used for private defense purposes only. Any rumors of Lion's Guard operations to destabilize other markets to make way for a Sindrian Fuel franchise are completely unsubstantiated, and clearly they come from jealous rivals intending to tarnish the company's pristine public image. And for Ludd's sake, don't ask why the Guard's named for a Lion.");
    }

    @Override
    public void onNewGameAfterEconomyLoad() {
        MarketAPI volturn = Global.getSector().getEconomy().getMarket("volturn");
        if (volturn != null) {
            addGrandFuelFleet();
            MarketAPI nachiketa = Global.getSector().getEconomy().getMarket("nachiketa");
            if (nachiketa != null) {
                addNFTMerchantMilitia();
            }
            ImportantPeopleAPI ip = Global.getSector().getImportantPeople();
            SectorAPI sector = Global.getSector();
            StarSystemAPI system = sector.getStarSystem("Askonia");
            MarketAPI market = Global.getSector().getEconomy().getMarket("sindria");


            if (market != null) {

                SectorEntityToken cnc = Global.getSector().getEntityById("diktat_cnc");
                cnc.setCustomDescriptionId("station_sindria_sindrian_fuel");

                PersonAPI sfckweenPerson = Global.getFactory().createPerson();
                sfckweenPerson.setId(sfckween);
                sfckweenPerson.setFaction(Factions.DIKTAT);
                sfckweenPerson.setGender(Gender.FEMALE);
                sfckweenPerson.setRankId(Ranks.SPACE_ADMIRAL);
                sfckweenPerson.setPostId("sfcheadresearcher");
                sfckweenPerson.setImportance(PersonImportance.HIGH);
                sfckweenPerson.setVoice(Voices.SCIENTIST);
                sfckweenPerson.getName().setFirst("Yunris");
                sfckweenPerson.getName().setLast("Kween");
                sfckweenPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfckween"));
                sfckweenPerson.addTag(Tags.CONTACT_UNDERWORLD);
                market.getCommDirectory().addPerson(sfckweenPerson, 2);
                market.addPerson(sfckweenPerson);
                ip.addPerson(sfckweenPerson);

                PersonAPI sfcmannPerson = Global.getFactory().createPerson();
                sfcmannPerson.setId(sfcmann);
                sfcmannPerson.setFaction(Factions.DIKTAT);
                sfcmannPerson.setGender(Gender.MALE);
                sfcmannPerson.setRankId(Ranks.SPACE_ADMIRAL);
                sfcmannPerson.setPostId("sfcleaddeveloper");
                sfcmannPerson.setImportance(PersonImportance.HIGH);
                sfcmannPerson.setVoice(Voices.SCIENTIST);
                sfcmannPerson.getName().setFirst("Gregory");
                sfcmannPerson.getName().setLast("Mannfred");
                sfcmannPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcmann"));
                sfcmannPerson.addTag(Tags.CONTACT_TRADE);
                market.getCommDirectory().addPerson(sfcmannPerson, 3);
                market.addPerson(sfcmannPerson);
                ip.addPerson(sfcmannPerson);

                // regular Yunifer
                PersonAPI sfcruniPerson = Global.getFactory().createPerson();
                sfcruniPerson.setId(sfcruni);
                sfcruniPerson.setFaction(Factions.DIKTAT);
                sfcruniPerson.setGender(Gender.FEMALE);
                sfcruniPerson.setRankId(Ranks.SPACE_CAPTAIN);
                sfcruniPerson.setPostId(Ranks.POST_OFFICER);
                sfcruniPerson.setPersonality(Personalities.TIMID);
                sfcruniPerson.setImportance(PersonImportance.VERY_LOW);
                sfcruniPerson.setVoice(Voices.SOLDIER);
                sfcruniPerson.getName().setFirst("Yunifer");
                sfcruniPerson.getName().setLast("Runi");
                sfcruniPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcruni"));
                sfcruniPerson.getStats().setSkillLevel("sfc_titan", 3);
                sfcruniPerson.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 3);
                sfcruniPerson.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 3);
                sfcruniPerson.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 3);
                sfcruniPerson.getStats().setSkillLevel(Skills.FIELD_MODULATION, 3);
                sfcruniPerson.getStats().setSkillLevel(Skills.IMPACT_MITIGATION, 3);
                sfcruniPerson.getStats().setSkillLevel(Skills.HELMSMANSHIP, 3);
                sfcruniPerson.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 3);
                sfcruniPerson.getStats().setSkillLevel(Skills.ENERGY_WEAPON_MASTERY, 3);
                sfcruniPerson.getStats().setSkillLevel(Skills.POLARIZED_ARMOR, 3);
                sfcruniPerson.getStats().setLevel(10);
                sfcruniPerson.getMemoryWithoutUpdate().set("$chatterChar", "sfcruni");
                sfcruniPerson.getMemoryWithoutUpdate().set("$nex_noOfficerDeath", true);

                market.getCommDirectory().addPerson(sfcruniPerson);
                market.addPerson(sfcruniPerson);
                market.getCommDirectory().getEntryForPerson(sfcruniPerson).setHidden(true);
                ip.addPerson(sfcruniPerson);

                PersonAPI sfcruni2Person = Global.getFactory().createPerson();
                sfcruni2Person.setId(sfcruni2);
                sfcruni2Person.setFaction(Factions.DIKTAT);
                sfcruni2Person.setGender(Gender.FEMALE);
                sfcruni2Person.setRankId(Ranks.SPACE_CAPTAIN);
                sfcruni2Person.setPostId(Ranks.POST_OFFICER);
                sfcruni2Person.setPersonality(Personalities.STEADY);
                sfcruni2Person.setImportance(PersonImportance.VERY_LOW);
                sfcruni2Person.setVoice(Voices.SOLDIER);
                sfcruni2Person.getName().setFirst("Yunifer");
                sfcruni2Person.getName().setLast("Runi");
                sfcruni2Person.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcruni2"));
                sfcruni2Person.getStats().setLevel(1);
                sfcruni2Person.getStats().setSkillLevel(Skills.GUNNERY_IMPLANTS, 1);
                sfcruni2Person.getMemoryWithoutUpdate().set("$chatterChar", "sfcthisofficer");
                sfcruni2Person.getMemoryWithoutUpdate().set("$nex_noOfficerDeath", true);

                market.getCommDirectory().addPerson(sfcruni2Person);
                market.addPerson(sfcruni2Person);
                market.getCommDirectory().getEntryForPerson(sfcruni2Person).setHidden(true);
                ip.addPerson(sfcruni2Person);

                PersonAPI sfcfakeandradaPerson = Global.getFactory().createPerson();
                sfcfakeandradaPerson.setId(sfcfakeandrada);
                sfcfakeandradaPerson.setFaction(Factions.NEUTRAL);
                sfcfakeandradaPerson.setGender(Gender.MALE);
                sfcfakeandradaPerson.setRankId("Hologram");
                sfcfakeandradaPerson.setPostId("Hologram");
                sfcfakeandradaPerson.getName().setFirst("Phillip");
                sfcfakeandradaPerson.getName().setLast("Andrada");
                sfcfakeandradaPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcfakeandrada"));
                ip.addPerson(sfcfakeandradaPerson);
            }

            market = Global.getSector().getEconomy().getMarket("cruor");
            if (market != null) {

                market.addSubmarket("sfc_bsamarket");

                SectorEntityToken cruor = system.getEntityById("cruor");
                cruor.getMarket().addIndustry(Industries.PATROLHQ);

                PersonAPI sfcdunnPerson = Global.getFactory().createPerson();
                sfcdunnPerson.setId(sfcdunn);
                sfcdunnPerson.setFaction(Factions.DIKTAT);
                sfcdunnPerson.setGender(Gender.MALE);
                sfcdunnPerson.setRankId(Ranks.SPACE_ADMIRAL);
                sfcdunnPerson.setPostId("sfclaborchief");
                sfcdunnPerson.setImportance(PersonImportance.HIGH);
                sfcdunnPerson.getName().setFirst("Meridin");
                sfcdunnPerson.getName().setLast("Dunn");
                sfcdunnPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcdunn"));
                sfcdunnPerson.addTag(Tags.CONTACT_TRADE);
                sfcdunnPerson.setVoice(Voices.SPACER);
                sfcdunnPerson.getStats().setSkillLevel("sfc_hardwork", 1);
                market.setAdmin(sfcdunnPerson);
                market.getCommDirectory().addPerson(sfcdunnPerson, 0);
                market.addPerson(sfcdunnPerson);
                ip.addPerson(sfcdunnPerson);

                PersonAPI sfcruyPerson = Global.getFactory().createPerson();
                sfcruyPerson.setId(sfcruy);
                sfcruyPerson.setFaction(Factions.DIKTAT);
                sfcruyPerson.setGender(Gender.MALE);
                sfcruyPerson.setRankId(Ranks.SPACE_ADMIRAL);
                sfcruyPerson.setPostId("sfcsecchief");
                sfcruyPerson.setImportance(PersonImportance.MEDIUM);
                sfcruyPerson.getName().setFirst("Rudric");
                sfcruyPerson.getName().setLast("Ruy");
                sfcruyPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcruy"));
                sfcruyPerson.addTag(Tags.CONTACT_MILITARY);
                sfcruyPerson.setVoice(Voices.SOLDIER);
                market.getCommDirectory().addPerson(sfcruyPerson, 1);
                market.addPerson(sfcruyPerson);
                ip.addPerson(sfcruyPerson);

                // CSP reference
                PersonAPI cspmongaeraPerson = Global.getFactory().createPerson();
                cspmongaeraPerson.setId(cspmongaera);
                cspmongaeraPerson.setFaction(Factions.LIONS_GUARD);
                cspmongaeraPerson.setGender(Gender.FEMALE);
                cspmongaeraPerson.setRankId("sfcregmanager");
                cspmongaeraPerson.setPostId("sfcregmanager");
                cspmongaeraPerson.setImportance(PersonImportance.VERY_HIGH);
                cspmongaeraPerson.getName().setFirst("Cayista");
                cspmongaeraPerson.getName().setLast("Mongaera");
                cspmongaeraPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "cspmongaera"));
                cspmongaeraPerson.addTag(Tags.CONTACT_MILITARY);
                cspmongaeraPerson.setVoice(Voices.SOLDIER);
                market.getCommDirectory().addPerson(cspmongaeraPerson, 0);
                market.addPerson(cspmongaeraPerson);
                market.getCommDirectory().getEntryForPerson(cspmongaeraPerson).setHidden(true);
                ip.addPerson(cspmongaeraPerson);

            }

            market = Global.getSector().getEconomy().getMarket("volturn");
            if (market != null) {

/*                SectorEntityToken volturncolony = system.getEntityById("volturn");
                volturncolony.getMarket().getIndustry(Industries.AQUACULTURE).setSpecialItem(new SpecialItemData("sfc_aquaticsimulator", null));
*/
                PersonAPI sfcfleuresPerson = Global.getFactory().createPerson();
                sfcfleuresPerson.setId(sfcfleures);
                sfcfleuresPerson.setFaction(Factions.DIKTAT);
                sfcfleuresPerson.setGender(Gender.FEMALE);
                sfcfleuresPerson.setRankId(Ranks.SPACE_ADMIRAL);
                sfcfleuresPerson.setPostId("sfcadvertchief");
                sfcfleuresPerson.setImportance(PersonImportance.HIGH);
                sfcfleuresPerson.getName().setFirst("Lumi");
                sfcfleuresPerson.getName().setLast("Fleures");
                sfcfleuresPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcfleures"));
                sfcfleuresPerson.addTag(Tags.CONTACT_TRADE);
                sfcfleuresPerson.setVoice(Voices.OFFICIAL);
                sfcfleuresPerson.getStats().setSkillLevel("sfc_hardwork", 1);
                market.setAdmin(sfcfleuresPerson);
                market.getCommDirectory().addPerson(sfcfleuresPerson, 0);
                market.addPerson(sfcfleuresPerson);
                ip.addPerson(sfcfleuresPerson);

                PersonAPI sfcjenkinsPerson = Global.getFactory().createPerson();
                sfcjenkinsPerson.setId(sfcjenkins);
                sfcjenkinsPerson.setFaction(Factions.DIKTAT);
                sfcjenkinsPerson.setGender(Gender.FEMALE);
                sfcjenkinsPerson.setRankId(Ranks.SPACE_ADMIRAL);
                sfcjenkinsPerson.setPostId("sfcproductionchief");
                sfcjenkinsPerson.setImportance(PersonImportance.HIGH);
                sfcjenkinsPerson.getName().setFirst("Valmarie");
                sfcjenkinsPerson.getName().setLast("Jenkins");
                sfcjenkinsPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcjenkins"));
                sfcjenkinsPerson.addTag(Tags.CONTACT_TRADE);
                sfcjenkinsPerson.setVoice(Voices.OFFICIAL);
                market.getCommDirectory().addPerson(sfcjenkinsPerson, 1);
                market.addPerson(sfcjenkinsPerson);
                ip.addPerson(sfcjenkinsPerson);
            }
            //the nft starts here
            market = Global.getSector().getEconomy().getMarket("nachiketa");
            if (market != null) {
                PersonAPI nftpononziPerson = Global.getFactory().createPerson();
                nftpononziPerson.setId(nftpononzi);
                nftpononziPerson.setFaction(Factions.HEGEMONY);
                nftpononziPerson.setGender(Gender.MALE);
                nftpononziPerson.setRankId("nftexecutive");
                nftpononziPerson.setPostId("nftexecutive");
                nftpononziPerson.setImportance(PersonImportance.VERY_HIGH);
                nftpononziPerson.getName().setFirst("Karlos");
                nftpononziPerson.getName().setLast("Pononzi");
                nftpononziPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "nftpononzi"));
                nftpononziPerson.addTag(Tags.CONTACT_TRADE);
                nftpononziPerson.setVoice(Voices.BUSINESS);
                market.getCommDirectory().addPerson(nftpononziPerson, 1);
                market.addPerson(nftpononziPerson);
                ip.addPerson(nftpononziPerson);
            }

            market = Global.getSector().getEconomy().getMarket("nortia");
            if (market != null){
                PersonAPI nftgimletPerson = Global.getFactory().createPerson();
                nftgimletPerson.setId(nftgimlet);
                nftgimletPerson.setFaction(Factions.HEGEMONY);
                nftgimletPerson.setGender(Gender.MALE);
                nftgimletPerson.setRankId(Ranks.GROUND_GENERAL);
                nftgimletPerson.setPostId(Ranks.POST_SUPPLY_OFFICER);
                nftgimletPerson.setImportance(PersonImportance.HIGH);
                nftgimletPerson.getName().setFirst("Darington");
                nftgimletPerson.getName().setLast("Gimlet");
                nftgimletPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters","nftgimlet"));
                nftgimletPerson.addTag(Tags.CONTACT_MILITARY);
                nftgimletPerson.setVoice(Voices.SOLDIER);
                market.getCommDirectory().addPerson(nftgimletPerson, 1);
                market.addPerson(nftgimletPerson);
                ip.addPerson(nftgimletPerson);
            }

            PersonAPI sec_officer = Global.getSector().getImportantPeople().getPerson("sec_officer");
            if (sec_officer != null) {
                sec_officer.setRankId("sfcjunior");
                sec_officer.setPostId("sfcjunior");
                sec_officer.addTag(Tags.CONTACT_MILITARY);
            }

            PersonAPI andrada = Global.getSector().getImportantPeople().getPerson("andrada");
            if (andrada != null) {
                andrada.getStats().setSkillLevel("sfc_hardwork", 1);
            }
            // DE reference
            if (isDE) {
                boolean DEenablelitemode = Global.getSettings().getBoolean("DEenablelitemode");
                MarketAPI market2 = null;
                MarketAPI market3 = null;
                if (!DEenablelitemode) {
                    market2 = Global.getSector().getStarSystem("Andor").getEntityById("ryzan_supercomplex").getMarket();
                    //market = Global.getSector().getEconomy().getMarket("ryzan_supercomplex");
                    if (market2 != null) {
                        PersonAPI dejalectoPerson = Global.getFactory().createPerson();
                        dejalectoPerson.setId(dejalecto);
                        dejalectoPerson.setFaction(Factions.LIONS_GUARD);
                        dejalectoPerson.setGender(Gender.MALE);
                        dejalectoPerson.setRankId("sfcexecutive");
                        dejalectoPerson.setPostId("sfcregmanager");
                        dejalectoPerson.setImportance(PersonImportance.VERY_HIGH);
                        dejalectoPerson.getName().setFirst("Randall");
                        dejalectoPerson.getName().setLast("Jalecto");
                        dejalectoPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "dejalecto"));
                        dejalectoPerson.getStats().setSkillLevel(Skills.INDUSTRIAL_PLANNING, 1);
                        dejalectoPerson.getStats().setSkillLevel(Skills.TACTICAL_DRILLS, 1);
                        market2.setAdmin(dejalectoPerson);
                        market2.getCommDirectory().addPerson(dejalectoPerson, 0);
                        market2.addPerson(dejalectoPerson);
                        ip.addPerson(dejalectoPerson);
                    } else {
                        market3 = Global.getSector().getEconomy().getMarket("sindria");
                        if (market3 != null) {
                            PersonAPI dejalectoPerson = Global.getFactory().createPerson();
                            dejalectoPerson.setId(dejalecto);
                            dejalectoPerson.setFaction(Factions.LIONS_GUARD);
                            dejalectoPerson.setGender(Gender.MALE);
                            dejalectoPerson.setRankId("sfcexecutive");
                            dejalectoPerson.setPostId("sfcexecutive");
                            dejalectoPerson.setImportance(PersonImportance.VERY_HIGH);
                            dejalectoPerson.getName().setFirst("Randall");
                            dejalectoPerson.getName().setLast("Jalecto");
                            dejalectoPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "dejalecto"));
                            market3.getCommDirectory().addPerson(dejalectoPerson, 1);
                            market3.addPerson(dejalectoPerson);
                            //market.getCommDirectory().getEntryForPerson(dejalectoPerson).setHidden(true);
                            ip.addPerson(dejalectoPerson);
                        }
                    }
                }
            }
            // CSP reference
/*           if (isCSP) {
                MarketAPI market4 = Global.getSector().getEconomy().getMarket("cruor");
                if (market4 != null) {
                    PersonAPI cspmongaeraPerson = Global.getFactory().createPerson();
                    cspmongaeraPerson.setId(cspmongaera);
                    cspmongaeraPerson.setFaction(Factions.LIONS_GUARD);
                    cspmongaeraPerson.setGender(Gender.FEMALE);
                    cspmongaeraPerson.setRankId("sfcregmanager");
                    cspmongaeraPerson.setPostId("sfcregmanager");
                    cspmongaeraPerson.setImportance(PersonImportance.VERY_HIGH);
                    cspmongaeraPerson.getName().setFirst("Calista");
                    cspmongaeraPerson.getName().setLast("mongaera");
                    cspmongaeraPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "cspmongaera"));
                    cspmongaeraPerson.addTag(Tags.CONTACT_MILITARY);
                    cspmongaeraPerson.setVoice(Voices.SOLDIER);
                    market4.getCommDirectory().addPerson(cspmongaeraPerson, 0);
                    market4.addPerson(cspmongaeraPerson);
                    market4.getCommDirectory().getEntryForPerson(cspmongaeraPerson).setHidden(true);
                    ip.addPerson(cspmongaeraPerson);
                }
            }*/
        }
    }
}